import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;

public class FileSelector extends JDialog implements ActionListener
{
  private boolean changed;

  private JEditorPane editorPane;
  private JScrollPane scrollPane;
  private JLabel fileNameLabel;
  private JTextField fileNameInput;
  private JButton okButton;
  private JButton cancelButton;

  public FileSelector(JFrame owner, int width, int height, String baseURL)
  {
    super(owner, "Browser", true);
		editorPane = new JEditorPane();
		editorPane.setEditable(false);
		setPage(editorPane, baseURL);
		scrollPane = new JScrollPane(editorPane);
    fileNameLabel = new JLabel("File Name");
    fileNameInput = new JTextField("", 10);
    okButton = new JButton("Ok");
    okButton.addActionListener(this);
    cancelButton = new JButton("Cancel");
    cancelButton.addActionListener(this);
    JPanel fileNamePanel = new JPanel();
    fileNamePanel.setLayout(new FlowLayout(FlowLayout.CENTER));
    fileNamePanel.add(fileNameLabel);
    fileNamePanel.add(fileNameInput);
    fileNamePanel.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), ""));
    JPanel buttonPanel = new JPanel();
    buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
    buttonPanel.add(okButton);
    buttonPanel.add(cancelButton);
    JPanel controlPanel = new JPanel();
    controlPanel.setLayout(new GridLayout(2, 1, 5, 5));
    controlPanel.add(fileNamePanel);
    controlPanel.add(buttonPanel);
    JPanel basePanel = new JPanel();
    basePanel.setBorder(BorderFactory.createLineBorder(basePanel.getBackground(), 15));
    basePanel.setLayout(new BorderLayout(0, 5));
    basePanel.add(scrollPane, BorderLayout.CENTER);
    basePanel.add(controlPanel, BorderLayout.SOUTH);
    add(basePanel);
    pack();
    setSize(width, height);
    setResizable(false);
    basePanel.requestFocus();
    changed = false;
  }

 	private void setPage(JEditorPane ep, String url)
  {
		try
    {
			ep.setPage(url);
		}
		catch (IOException e)
    {
      e.printStackTrace();
		}
  }

  public String getFileName()
  {
    return fileNameInput.getText();
  }

  public boolean hasChanged()
  {
    return changed;
  }

  public void actionPerformed(ActionEvent e)
  {
    Object source = e.getSource();
    if (source == okButton)
    {
      setVisible(false);
      changed = true;
    }
    else if (source == cancelButton)
    {
      setVisible(false);
      changed = false;
    }
  }
}

