import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

class TextSpinner extends JLabel implements MouseListener
{
  private String[] textArray;
  private int selectedIndex;

  public TextSpinner(int height, int width, String[] textArray)
  {
    super("", CENTER);
    this.textArray = textArray;
    addMouseListener(this);
    setPreferredSize(new Dimension(height, width));
    setBorder(BorderFactory.createEtchedBorder());
    selectedIndex = 0;
  }

  public void setSelectedIndex(int value)
  {
    selectedIndex = value;
  }

  public void mousePressed(MouseEvent e)
  {
    selectedIndex = (selectedIndex + 1) % textArray.length;
    setText(textArray[selectedIndex]);
  }

  public void mouseExited(MouseEvent e) {}
  public void mouseClicked(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
}
